#include "GraphicsObject.h"

IMPLEMENT_SERIAL(GraphicsObject, CObject, 0); // 0 = Versionsnummer

GraphicsObject::GraphicsObject(int t, int x, int y) :
type(t), x0(x), y0(y)
{ }

GraphicsObject::GraphicsObject() :
type(-1), x0(-1), y0(-1)
{ }

void GraphicsObject::draw(CDC *dc, BOOL isViewFilled)
{
	if(isViewFilled)
	{
		dc->SelectStockObject(NULL_PEN); // kein Umriss
		dc->SelectStockObject(GRAY_BRUSH); // grau gefllt		
	}
	else
	{
		dc->SelectStockObject(BLACK_PEN); // schwarzer Umriss
		dc->SelectStockObject(NULL_BRUSH); // nicht gefllt		
	}

	switch(type)
	{
	case RECT:
		dc->Rectangle(x0, y0, x0+40, y0+25);
		break;
	case HELLIPSE:
		dc->Ellipse(x0, y0, x0+50, y0+20);
		break;
	case VELLIPSE:
		dc->Ellipse(x0, y0, x0+20, y0+50);
		break;
	case CIRCLE:
		dc->Ellipse(x0, y0, x0+30, y0+30);
		break;
	}
}

BOOL GraphicsObject::isInside(CPoint p)
{
	CRect boundingBox;

	switch(type)
	{
	case RECT:
		boundingBox = CRect(x0, y0, x0+40, y0+25);
		break;
	case HELLIPSE:
		boundingBox = CRect(x0, y0, x0+50, y0+20);
		break;
	case VELLIPSE:
		boundingBox = CRect(x0, y0, x0+20, y0+50);
		break;
	case CIRCLE:
		boundingBox = CRect(x0, y0, x0+30, y0+30);
		break;
	}
	
	return boundingBox.PtInRect(p);
}

int GraphicsObject::getType()
{
	return type;
}

void GraphicsObject::setType(int t)
{
	type = t;
}

void GraphicsObject::Serialize(CArchive& ar)
{
	CObject::Serialize(ar); // Mutterklasse sichern
	
	if(ar.IsStoring()) // wir wollen speichern
	{
		ar << x0 << y0 << type; // Diese Operatoren sind passend berladen.
	}
	else // wir wollen landen
	{
		ar >> x0 >> y0 >> type;
	}
}
